import pandas as pd

def lnc_filter(data):
    data = data.dropna().drop_duplicates()
    lncrans = pd.read_csv("data/LncSEA+NONCODE+GENCODE.lnc.txt")
    lncrans = set(lncrans["LncRNA"])
    print("---------------Shape: ---------------",data.shape)
    data = data[data.LncRNA.apply(lambda x:x in lncrans)]
    print("---------------Shape: ---------------",data.shape)
    return data

def expand_row(data,col,split=","):
    r = data[col].str.split(split,expand=True)
    r = r.stack().reset_index(level=1, drop=True).dropna().rename(col)
    data = data.drop([col],axis=1).join(r)
    return data

def run(data_path, detail_path):
    ## LncACTdb ##
    # LncACTdb
    print("-----------LncACTdb------------")
    data = pd.read_excel(data_path[0])
    data_stack = data.iloc[:,5:15].stack().reset_index().set_index("level_0")
    data_stack = data_stack[data_stack[0]==1]
    data = data.iloc[:,:5].join(data_stack)
    data = data[["level_1","biomarker name","cancer type","methods","pubmed id"]]
    data.columns = ["Set", "LncRNA", "D1_CancerType","D2_Methods","D3_Pubmed"]
    data = lnc_filter(data)
    data["Sub_Class"] = "LncACTdb"
    data["Class"] = "Cancer_Functional_State"
    data.to_csv(detail_path[0], index=False)

run(snakemake.input, snakemake.output)
