import pandas as pd

def lnc_filter(data):
    data = data.dropna().drop_duplicates()
    lncrans = pd.read_csv("data/LncSEA+NONCODE+GENCODE.lnc.txt")
    lncrans = set(lncrans["LncRNA"])
    print("---------------Shape: ---------------",data.shape)
    data = data[data.LncRNA.apply(lambda x:x in lncrans)]
    print("---------------Shape: ---------------",data.shape)
    return data

def expand_row(data,col,split=","):
    r = data[col].str.split(split,expand=True)
    r = r.stack().reset_index(level=1, drop=True).dropna().rename(col)
    data = data.drop([col],axis=1).join(r)
    return data

def run(data_path, detail_path):
    ## CellMarker2.0 ##
    # CellMarker2.0
    print("-----------CellMarker2.0------------")
    data = pd.read_excel(data_path[0])
    data = data[["cell_name","marker","tissue_class","cancer_type","cell_type","cellontology_id","marker_source","PMID"]]
    data = data[data["cell_name"].astype(str).map(lambda x:bool(x.strip()))]
    data.columns = ["Set","LncRNA","D1_Tissue_type","D2_Cancer_type","D3_Cell_type","D4_Cellontology_id","D5_Marker_source","D6_Pubmed"]
    data = lnc_filter(data)
    data["Sub_Class"] = "CellMarker2.0"
    data["Class"] = "Cell_Marker"
    data.to_csv(detail_path[0], index=False)

run(snakemake.input, snakemake.output)
