import pandas as pd


def lnc_filter(data):
    data = data.dropna().drop_duplicates()
    lncrans = pd.read_csv("data/LncSEA+NONCODE+GENCODE.lnc.txt")
    lncrans = set(lncrans["LncRNA"])
    print("---------------Shape: ---------------",data.shape)
    data = data[data.LncRNA.apply(lambda x:x in lncrans)]
    print("---------------Shape: ---------------",data.shape)
    return data

def expand_row(data,col,split=","):
    r = data[col].str.split(split,expand=True)
    r = r.stack().reset_index(level=1, drop=True).dropna().rename(col)
    data = data.drop([col],axis=1).join(r)
    return data

def run(data_path, detail_path):
    ## CR_ChIP_seq ##
    # CR_ChIP_seq
    print("------------CR_ChIP_seq------------")
    data = pd.read_csv(data_path[0],sep="\t")
    data = data[["regulatoryGene","targetGene"]]
    data.columns = ["Set", "LncRNA"]
    data = lnc_filter(data)
    data["Sub_Class"] = "CR_ChIP_seq"
    data["Class"] = "Chromatin_Regulators"
    data.to_csv(detail_path[0], index=False)


run(snakemake.input, snakemake.output)
