import re

import pandas as pd


def run(input, output):
    lncrans = pd.read_csv("data/LncSEA+NONCODE+GENCODE.lnc.txt")
    set_tables = list(filter(lambda x: "set_" in x, input))
    for table in set_tables:
        data = pd.read_csv(table)["LncRNA"]
        data = data.values.tolist()
        r = []
        for row in data:
            r.extend(row.split(","))
        r = pd.DataFrame(r)
        r[1] = r[0]
        r = dict(r.groupby(0).agg(len).reset_index().values.tolist())

        def get_value(lnc):
            try:
                return r[lnc]
            except:
                return 0

        class_ = re.findall("set_(.*?).txt", table)[0]
        lncrans[class_] = lncrans["LncRNA"].apply(lambda lnc: get_value(lnc))
        print("----final ", class_)

    lncrans.to_csv(output[0], index=False)


run(snakemake.input, snakemake.output)
