import pandas as pd
import re

def lnc_filter(data):
    data = data.dropna().drop_duplicates()
    data['Set'] = data['Set'].map(lambda x:re.sub("(?:-|/)","__",x))
    lncrans = pd.read_csv("data/LncSEA+NONCODE+GENCODE.lnc.txt")
    lncrans = set(lncrans["LncRNA"])
    print("---------------Shape: ---------------",data.shape)
    data = data[data.LncRNA.apply(lambda x:x in lncrans)]
    print("---------------Shape: ---------------",data.shape)
    return data

def expand_row(data,col,split=","):
    r = data[col].str.split(split,expand=True)
    r = r.stack().reset_index(level=1, drop=True).dropna().rename(col)
    data = data.drop([col],axis=1).join(r)
    return data

def run(data_path, detail_path):
    ## EVLncRNAs2.0 ##
    # EVLncRNAs2.0
    print("------------EVLncRNAs2.0------------")
    data = pd.read_excel(data_path[0])
    data = data[data["Species"] == "Homo sapiens"]
    data = data[["Disease","Name","Methods","Sample","PMID"]]
    data.columns = ["Set", "LncRNA", "D1_Methods","D2_Sample","D3_Pubmed"]
    data["Set"] = data["Set"].str.lower()
    data = lnc_filter(data)
    data["Sub_Class"] = "EVLncRNAs2.0"
    data["Class"] = "Disease_Type"
    data.to_csv(detail_path[0], index=False)


run(snakemake.input, snakemake.output)
