from glob import glob
import os
import pandas as pd


def lnc_filter(data):
    data = data.dropna().drop_duplicates()
    lncrans = pd.read_csv("data/LncSEA+NONCODE+GENCODE.lnc.txt")
    lncrans = set(lncrans["LncRNA"])
    print("---------------Shape: ---------------", data.shape)
    data = data[data.LncRNA.apply(lambda x: x in lncrans)]
    print("---------------Shape: ---------------", data.shape)
    return data


def expand_row(data, col, split=","):
    r = data[col].str.split(split, expand=True)
    r = r.stack().reset_index(level=1, drop=True).dropna().rename(col)
    data = data.drop([col], axis=1).join(r)
    return data


def run(data_path, detail_path):
    ## LncTarD ##
    # LncTarD
    os.system(f"iconv -f ISO-8859-1 -t UTF-8 {data_path[0]} > {data_path[0]}.tem")
    print("------------LncTarD------------")
    data = pd.read_csv(f"{data_path[0]}.tem", sep="\t")
    data = data[
        [
            "influencedFunction",
            "Regulator",
            "Target",
            "DiseaseName",
            "SearchregulatoryMechanism",
            "Experimental.method.for.lncRNA.target",
            "PubMedID",
        ]
    ]
    data.columns = [
        "Set",
        "LncRNA",
        "D1_Target",
        "D2_DiseaseName",
        "D3_SearchregulatoryMechanism",
        "D4_Experimental_method",
        "D5_Pubmed",
    ]
    data = expand_row(data, "Set", split=";")
    data["Sub_Class"] = "LncTarD2.0"
    data["Class"] = "Experimental_Validated_Function"
    data.to_csv(detail_path[0], index=False)


run(snakemake.input, snakemake.output)
