import pandas as pd


def lnc_filter(data):
    data = data.dropna().drop_duplicates()
    lncrans = pd.read_csv("data/LncSEA+NONCODE+GENCODE.lnc.txt")
    lncrans = set(lncrans["LncRNA"])
    print("---------------Shape: ---------------", data.shape)
    data = data[data.LncRNA.apply(lambda x: x in lncrans)]
    print("---------------Shape: ---------------", data.shape)
    return data


def expand_row(data, col, split=","):
    r = data[col].str.split(split, expand=True)
    r = r.stack().reset_index(level=1, drop=True).dropna().rename(col)
    data = data.drop([col], axis=1).join(r)
    return data


def run(data_path, detail_path):
    ## ncRI ##
    # ncRI
    print("------------ncRI------------")
    data = pd.read_excel(data_path[0])
    data = data[data["Category"] == "lncRNA"]
    data = data[
        [
            "Disease",
            "NAME",
            "Expression_Pattern",
            "Throughput",
            "Detection_Methods",
            "Tissues|Cells",
            "PMID",
        ]
    ]
    data.columns = [
        "Set",
        "LncRNA",
        "D1_Expression_Pattern",
        "D2_Throughput",
        "D3_Detection_Methods",
        "D4_Tissues_Cells",
        "D5_PMID",
    ]
    data = lnc_filter(data)
    data["Sub_Class"] = "ncRI"
    data["Class"] = "Inflammation"
    data.to_csv(detail_path[0], index=False)


run(snakemake.input, snakemake.output)
