import pandas as pd


def lnc_filter(data):
    data = data.dropna().drop_duplicates()
    lncrans = pd.read_csv("data/LncSEA+NONCODE+GENCODE.lnc.txt")
    lncrans = set(lncrans["LncRNA"])
    print("---------------Shape: ---------------", data.shape)
    data = data[data.LncRNA.apply(lambda x: x in lncrans)]
    print("---------------Shape: ---------------", data.shape)
    return data


def expand_row(data, col, split=","):
    r = data[col].str.split(split, expand=True)
    r = r.stack().reset_index(level=1, drop=True).dropna().rename(col)
    data = data.drop([col], axis=1).join(r)
    return data


def run(data_path, detail_path):
    ## Lnc2Meth ##
    # Lnc2Meth
    print("-----------Lnc2Meth------------")
    data = pd.read_csv(data_path[0])
    data = data[
        [
            "Set",
            "LncRNA",
            "D1_region",
            "D2_Disease_state",
            "D3_Regulatory_mechanism",
            "D6_PubMed",
        ]
    ]
    data.columns = [
        "Set",
        "LncRNA",
        "D1_Region",
        "D2_Disease_state",
        "D3_Regulatory_mechanism",
        "D6_Pubmed",
    ]
    data["Sub_Class"] = "Lnc2Meth"
    data["Class"] = "Methylation_Pattern"
    data = data.dropna().drop_duplicates()
    data.to_csv(detail_path[0], index=False)


run(snakemake.input, snakemake.output)
