import pandas as pd


def lnc_filter(data):
    data = data.dropna().drop_duplicates()
    lncrans = pd.read_csv("data/LncSEA+NONCODE+GENCODE.lnc.txt")
    lncrans = set(lncrans["LncRNA"])
    print("---------------Shape: ---------------", data.shape)
    data = data[data.LncRNA.apply(lambda x: x in lncrans)]
    print("---------------Shape: ---------------", data.shape)
    return data


def expand_row(data, col, split=","):
    r = data[col].str.split(split, expand=True)
    r = r.stack().reset_index(level=1, drop=True).dropna().rename(col)
    data = data.drop([col], axis=1).join(r)
    return data


def run(data_path, detail_path):
    ## RNALocate2.0 ##
    # RNALocate2.0
    print("-----------RNALocate2.0------------")
    data = pd.read_csv(data_path[0], sep="\t")
    data = data[data["Species"] == "Homo sapiens"]
    data = data[
        data["RNA_category"].str.contains(
            "lncRNA|lincRNA|antisense RNA|processed_transcript"
        )
    ]
    data = data[["SubCellular_Localization", "Gene_symbol", "PMID"]]
    data.columns = ["Set", "LncRNA", "D1_Pubmed"]
    data = data.dropna().drop_duplicates()
    data["Sub_Class"] = "RNALocate2.0"
    data["Class"] = "Subcellular_Localization"
    data.to_csv(detail_path[0], index=False)


run(snakemake.input, snakemake.output)
