import pandas as pd


def lnc_filter(data):
    data = data.dropna().drop_duplicates()
    lncrans = pd.read_csv("data/LncSEA+NONCODE+GENCODE.lnc.txt")
    lncrans = set(lncrans["LncRNA"])
    print("---------------Shape: ---------------", data.shape)
    data = data[data.LncRNA.apply(lambda x: x in lncrans)]
    print("---------------Shape: ---------------", data.shape)
    return data


def expand_row(data, col, split=","):
    r = data[col].str.split(split, expand=True)
    r = r.stack().reset_index(level=1, drop=True).dropna().rename(col)
    data = data.drop([col], axis=1).join(r)
    return data


def run(data_path, detail_path):
    ## iLoc-lncRNA2.0 ##
    # iLoc-lncRNA2.0
    print("-----------iLoc-lncRNA2.0------------")
    data = pd.read_csv(data_path[0], sep="\t")
    data = data[["Subcellular location", "Annotation information", "Probability"]]
    data["Annotation information"] = data["Annotation information"].apply(
        lambda x: x.split("|")[-3]
    )
    data = data.drop_duplicates(["Annotation information"])
    data = data[data["Probability"] > 0.8]
    data.columns = ["Set", "LncRNA", "D1_Probability"]
    data = data.dropna().drop_duplicates()
    data["Sub_Class"] = "iLoc_lncRNA2.0"
    data["Class"] = "Subcellular_Localization"
    data.to_csv(detail_path[0], index=False)


run(snakemake.input, snakemake.output)
