from glob import glob
import os
import pandas as pd

def run(data_path, detail_path):
    ## Transcription_Factor ##
    # Transcription_Factor
    lncrans = pd.read_csv("data/LncSEA+NONCODE+GENCODE.lnc.txt")
    lncrans = set(lncrans["LncRNA"])
    print("------------Transcription_Factor------------")
    for path in data_path:
        print(path)
        data = pd.read_csv(path)
        data.columns = ["Set","LncRNA","D1_chr","D2_start","D3_end","D4_Version","Sub_Class","Class"]
        print("---------------Shape: ---------------", data.shape)
        data = data[data.LncRNA.apply(lambda x: x in lncrans)]
        print("---------------Shape: ---------------", data.shape)
        data.to_csv(path, index=False)
    
    os.system(f"echo > {detail_path[0]}")

run(snakemake.input, snakemake.output)
