import pandas as pd

def lnc_filter(data):
    data = data.dropna().drop_duplicates()
    lncrans = pd.read_csv("data/LncSEA+NONCODE+GENCODE.lnc.txt")
    lncrans = set(lncrans["LncRNA"])
    print("---------------Shape: ---------------",data.shape)
    data = data[data.LncRNA.apply(lambda x:x in lncrans)]
    print("---------------Shape: ---------------",data.shape)
    return data

def expand_row(data,col,split=","):
    r = data[col].str.split(split,expand=True)
    r = r.stack().reset_index(level=1, drop=True).dropna().rename(col)
    data = data.drop([col],axis=1).join(r)
    return data

def run(data_path,detail_path):
    ## LncR2metasta ##
    # LncR2metasta
    print("---------------LncR2metasta---------------")
    data = pd.read_excel(data_path[0])
    data = data[["Metastic event","LncRNA name","location","Strand","Cancer type","Description","Link"]]
    data.columns = ["Set","LncRNA","D1_Location","D2_Strand","D3_Cancer_type","D4_Description","D5_Pubmed"]
    data["D5_Pubmed"] = data["D5_Pubmed"].apply(lambda x:x.split("/")[-1])
    data = lnc_filter(data)
    data["Sub_Class"] = "LncR2metasta"
    data["Class"] = "Tumor_Metastasis"
    data.to_csv(detail_path[0], index=False)

run(snakemake.input, snakemake.output)
