import pandas as pd


def lnc_filter(data):
    data = data.dropna().drop_duplicates()
    lncrans = pd.read_csv("data/LncSEA+NONCODE+GENCODE.lnc.txt")
    lncrans = set(lncrans["LncRNA"])
    print("---------------Shape: ---------------",data.shape)
    data = data[data.LncRNA.apply(lambda x:x in lncrans)]
    print("---------------Shape: ---------------",data.shape)
    return data

def expand_row(data,col,split=","):
    r = data[col].str.split(split,expand=True)
    r = r.stack().reset_index(level=1, drop=True).dropna().rename(col)
    data = data.drop([col],axis=1).join(r)
    return data

def run(data_path, detail_path):
    ## Common_cis ##
    # Common_cis
    print("-----------Common_cis------------")
    data = pd.read_csv(data_path[0],encoding="gbk")
    data = data[data["Sub_Class"]=="Common_Cis"]
    data = data[["Set","LncRNA","D1_gene_id","D2_SNP_id","D3_statistic","D4_pvalue","D5_FDR","D6_beta","D7_r","D8_SNP_position","D9_Alleles","D10_Gene_position","D11_AA","D12_Aa","D13_aa"]]
    data.columns = ["Set","LncRNA","D1_gene_id","D2_SNP_id","D3_statistic","D4_pvalue","D5_FDR","D6_beta","D7_r","D8_SNP_position","D9_Alleles","D10_Gene_position","D11_AA","D12_Aa","D13_aa"]
    data = lnc_filter(data)
    data["Sub_Class"] = "Common_cis"
    data["Class"] = "eQTL"
    data.to_csv(detail_path[0], index=False)

run(snakemake.input, snakemake.output)
