import pandas as pd


def lnc_filter(data):
    data = data.dropna().drop_duplicates()
    lncrans = pd.read_csv("data/LncSEA+NONCODE+GENCODE.lnc.txt")
    lncrans = set(lncrans["LncRNA"])
    print("---------------Shape: ---------------",data.shape)
    data = data[data.LncRNA.apply(lambda x:x in lncrans)]
    print("---------------Shape: ---------------",data.shape)
    return data

def expand_row(data,col,split=","):
    r = data[col].str.split(split,expand=True)
    r = r.stack().reset_index(level=1, drop=True).dropna().rename(col)
    data = data.drop([col],axis=1).join(r)
    return data

def run(data_path,detail_path):
    ## m6A2Target ##
    # m6A2Target
    print("---------------m6A2Target---------------")
    data = pd.read_excel(data_path[0])
    data = data[["wername","targetgene","class","cell_line","perturbation","pertubation_method","PMID"]]
    data.columns = ["Set","LncRNA","D1_Type","D2_Cell_line","D3_Perturbation","D4_Pertubation_method","D5_Pubmed"]
    data = lnc_filter(data)
    data["Sub_Class"] = "m6A2Target"
    data["Class"] = "m6A_Modification"
    data.to_csv(detail_path[0], index=False)

run(snakemake.input, snakemake.output)
