import pandas as pd


def lnc_filter(data):
    data = data.dropna().drop_duplicates()
    lncrans = pd.read_csv("data/LncSEA+NONCODE+GENCODE.lnc.txt")
    lncrans = set(lncrans["LncRNA"])
    print("---------------Shape: ---------------", data.shape)
    data = data[data.LncRNA.apply(lambda x: x in lncrans)]
    print("---------------Shape: ---------------", data.shape)
    return data


def expand_row(data, col, split=","):
    r = data[col].str.split(split, expand=True)
    r = r.stack().reset_index(level=1, drop=True).dropna().rename(col)
    data = data.drop([col], axis=1).join(r)
    return data


def run(data_path, detail_path):
    ## KnockTF ##
    # KnockTF
    print("------------KnockTF------------")
    data = pd.read_csv(data_path[0], sep="\t")
    data = data[["TF", "Gene", "FC", "Log2FC", "P_value", "up_down"]]
    data.columns = ["Set", "LncRNA", "D1_FC", "D2_Log2FC", "D3_P_value", "D4_up_down"]
    data = lnc_filter(data)
    def to_float(x):
        try:
            return float(x)
        except:
            return 1
    data = data[data['D3_P_value'].apply(to_float)<0.05]
    data["Sub_Class"] = "KnockTF"
    data["Class"] = "Gene_Perturbation"
    data.to_csv(detail_path[0], index=False)


run(snakemake.input, snakemake.output)
